const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Loan_applicationsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const loan_applications = await db.loan_applications.create(
      {
        id: data.id || undefined,

        amount: data.amount || null,
        loan_type: data.loan_type || null,
        application_date: data.application_date || null,
        approved: data.approved || false,

        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await loan_applications.setPartner(data.partner || null, {
      transaction,
    });

    await loan_applications.setKooperatif(data.kooperatif || null, {
      transaction,
    });

    return loan_applications;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const loan_applicationsData = data.map((item, index) => ({
      id: item.id || undefined,

      amount: item.amount || null,
      loan_type: item.loan_type || null,
      application_date: item.application_date || null,
      approved: item.approved || false,

      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const loan_applications = await db.loan_applications.bulkCreate(
      loan_applicationsData,
      { transaction },
    );

    // For each item created, replace relation files

    return loan_applications;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const loan_applications = await db.loan_applications.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.amount !== undefined) updatePayload.amount = data.amount;

    if (data.loan_type !== undefined) updatePayload.loan_type = data.loan_type;

    if (data.application_date !== undefined)
      updatePayload.application_date = data.application_date;

    if (data.approved !== undefined) updatePayload.approved = data.approved;

    updatePayload.updatedById = currentUser.id;

    await loan_applications.update(updatePayload, { transaction });

    if (data.partner !== undefined) {
      await loan_applications.setPartner(
        data.partner,

        { transaction },
      );
    }

    if (data.kooperatif !== undefined) {
      await loan_applications.setKooperatif(
        data.kooperatif,

        { transaction },
      );
    }

    return loan_applications;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const loan_applications = await db.loan_applications.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of loan_applications) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of loan_applications) {
        await record.destroy({ transaction });
      }
    });

    return loan_applications;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const loan_applications = await db.loan_applications.findByPk(id, options);

    await loan_applications.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await loan_applications.destroy({
      transaction,
    });

    return loan_applications;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const loan_applications = await db.loan_applications.findOne(
      { where },
      { transaction },
    );

    if (!loan_applications) {
      return loan_applications;
    }

    const output = loan_applications.get({ plain: true });

    output.partner = await loan_applications.getPartner({
      transaction,
    });

    output.kooperatif = await loan_applications.getKooperatif({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userKooperatif = (user && user.kooperatif?.id) || null;

    if (userKooperatif) {
      if (options?.currentUser?.kooperatifId) {
        where.kooperatifId = options.currentUser.kooperatifId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.partners,
        as: 'partner',

        where: filter.partner
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.partner
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  name: {
                    [Op.or]: filter.partner
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.kooperatif,
        as: 'kooperatif',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.amountRange) {
        const [start, end] = filter.amountRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            amount: {
              ...where.amount,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            amount: {
              ...where.amount,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.application_dateRange) {
        const [start, end] = filter.application_dateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            application_date: {
              ...where.application_date,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            application_date: {
              ...where.application_date,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.loan_type) {
        where = {
          ...where,
          loan_type: filter.loan_type,
        };
      }

      if (filter.approved) {
        where = {
          ...where,
          approved: filter.approved,
        };
      }

      if (filter.kooperatif) {
        const listItems = filter.kooperatif.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          kooperatifId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.kooperatifId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.loan_applications.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('loan_applications', 'loan_type', query),
        ],
      };
    }

    const records = await db.loan_applications.findAll({
      attributes: ['id', 'loan_type'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['loan_type', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.loan_type,
    }));
  }
};
